{
*****************************************************************************
*  Name    : W5500-Consts.BAS                                               *
*  Author  : M.Cerutti                                                      *
*  Notice  : Copyright (c) 2014 [select VIEW...EDITOR OPTIONS]              *
*          : All Rights Reserved                                            *
*  Date    : 21/11/2014                                                     *
*  Version : 1.0                                                            *
*  Notes   :                                                                *
*          :                                                                *
*****************************************************************************
}
Module W5500_Consts
    Include "W5500-Utils"
    Include "W5500-Config"

Public Dim 
    HOST_NAME   As String, 
    Ip_Addr(4)  As Byte,
    Sub_Mask(4) As Byte,
    Gtw_Addr(4) As Byte,
    Dns_Addr(4) As Byte, 
    TCP_PORT    As Word 


Public Const
    cTCP_PORT           =   80,      // Porta TCP/IP 80
    MAX_SOCK_NUM        =   8,     

//----------------------------- W5500 Common Registers IOMAP -----------------------------
    rMR                 = $00,    // Mode
    rGAR0               = $01,    // Gateway Address            GAR0:GAR3
    rSUBR0              = $05,    // Subnet Mask Address        SUBR0:SUBR3
    rSHAR0              = $09,    // Source Hardware Address    SHAR0:SHAR5
    rSIPR0              = $0F,    // Source IP Address          SIPR0:SIPR3
    rINTLEVEL0          = $13,    // Int. Low Level Timer       INTLEVEL0:INTLEVEL1  
    rIR                 = $15,    // Interrupt
    rIMR                = $16,    // Interrupt Mask 
    rSIR                = $17,    // Socket Interrupt
    rSIMR               = $18,    // Socket Interrupt Mask      
    rRTR0               = $19,    // Retry Time                 RTR0:RTR1
    rRCR                = $1B,    // Retry Count
    rPTIMER             = $1C,    // PPP LCP Req. Timer
    rPMAGIC             = $1D,    // PPP LCP Magic Number
    rPHAR0              = $1E,    // PPP Dest. MAC Address      PHAR0:PHAR5
    rPSID0              = $24,    // PPP Session ID             PSID0:PSID1
    rPMRU0              = $26,    // PPP Max Segm. Size         PMRU0:PMRU1
    rUIPR0              = $28,    // Unreachable IP Address     UIPR0:UIPR3
    rUPORTR0            = $2C,    // Unreachable Port           UPORTR0:UPORTR1
    rPHYCFGR            = $2E,    // PHY Config
    rVERSIONR           = $39,    // Chip Version

//----------------------------- W5500 Socket(n) Registers IOMAP -----------------------------

    rSn_MR              = $00,    // Socket n Mode
    rSn_CR              = $01,    // Socket n Command
    rSn_IR              = $02,    // Socket n Interrupt
    rSn_SR              = $03,    // Socket n Status
    rSn_PORT0           = $04,    // Socket n Source Port       PORT0:PORT1      
    rSn_DHAR0           = $06,    // Socket n Dest.HW Address   DHAR0:DHAR5
    rSn_DIPR0           = $0C,    // Socket n Dest.IP Address   DIPR0:DIPR3
    rSn_DPORT0          = $10,    // Socket n Dest. Port        DPORT0:DPORT1
    rSn_MSSR0           = $12,    // Socket n Max Segm. Size    MSSR0:MSSR1
    rSn_PROTO           = $14,    // Socket n Proto  (24/3/2015)           
    rSn_TOS             = $15,    // Socket n IP TOS
    rSn_TTL             = $16,    // Socket n IP TTL
    rSn_RXBUF_SIZE      = $1E,    // Socket n Rcv. Buffer Size  
    rSn_TXBUF_SIZE      = $1F,    // Socket n Trm. Buffer Size
    rSn_TX_FSR0         = $20,    // Socket n TX Free Size      Sn_TX_FSR0:Sn_TX_FSR1
    rSn_TX_RD0          = $22,    // Socket n TX Read Ptr.      Sn_TX_RD0:Sn_TX_RD1      
    rSn_TX_WR0          = $24,    // Socket n TX Write Ptr.     Sn_TX_WR0:Sn_TX_WR1      
    rSn_RX_RSR0         = $26,    // Socket n RX Recvd. Size    Sn_RX_RSR0:Sn_RX_RSR1
    rSn_RX_RD0          = $28,    // Socket n RX Read Ptr.      Sn_RX_RD0:Sn_RX_RD1
    rSn_RX_WR0          = $2A,    // Socket n RX Write Ptr.     Sn_RX_WR0:Sn_RX_WR1
    rSn_IMR             = $2C,    // Socket n Int. Mask
    rSn_FRAG0           = $2D,    // Socket n Frgm. Offset Hdr  FRAG0:FRAG1 
    rSn_KPALVTR         = $2F,    // Socket n Keep Alive Timer


    cMR_RST             = $80,
    cMR_WOL             = $20,
    cMR_PB              = $10,
    cMR_PPPOE           = $08,
    cMR_FARP            = $02,
    
    cIR_CONFLICT        = $80,
    cIR_UNREACH         = $40,
    cIR_PPPoE           = $20,
    cIR_MP              = $10,

//* PHYCFGR register value */
'#define PHYCFGR_RST                  ~(1<<7)  //< For PHY reset, must operate AND mask.
'#define PHYCFGR_OPMD                 (1<<6)   // Configre PHY with OPMDC value
'#define PHYCFGR_OPMDC_ALLA           (7<<3)
'#define PHYCFGR_OPMDC_PDOWN          (6<<3)
'#define PHYCFGR_OPMDC_NA             (5<<3)
'#define PHYCFGR_OPMDC_100FA          (4<<3)
'#define PHYCFGR_OPMDC_100F           (3<<3)
'#define PHYCFGR_OPMDC_100H           (2<<3)
'#define PHYCFGR_OPMDC_10F            (1<<3)
'#define PHYCFGR_OPMDC_10H            (0<<3)           
'#define PHYCFGR_DPX_FULL             (1<<2)
'#define PHYCFGR_DPX_HALF             (0<<2)
'#define PHYCFGR_SPD_100              (1<<1)
'#define PHYCFGR_SPD_10               (0<<1)
'#define PHYCFGR_LNK_ON               (1<<0)
'#define PHYCFGR_LNK_OFF              (0<<0)

    cIM_IR7             = $80,
    cIM_IR6             = $40,
    cIM_IR5             = $20,
    cIM_IR4             = $10,

    cSn_MR_MULTI        = $80,
    cSn_MR_BCASTB       = $40,
    cSn_MR_ND           = $20,
    cSn_MR_UCASTB       = $10,
    cSn_MR_MACRAW       = $04,
    cSn_MR_IPRAW        = $03,       // 24/3/2015
    cSn_MR_UDP          = $02,
    cSn_MR_TCP          = $01,
    cSn_MR_CLOSE        = $00,
    cSn_MR_MFEN         = cSn_MR_MULTI,
    cSn_MR_MMB          = cSn_MR_ND,
    cSn_MR_MIP6B        = cSn_MR_UCASTB,
    cSn_MR_MC           = cSn_MR_ND,
    
    cSOCK_STREAM        = cSn_MR_TCP,
    cSOCK_DGRAM         = cSn_MR_UDP,
    
    cSn_CR_OPEN         = $01,
    cSn_CR_LISTEN       = $02,
    cSn_CR_CONNECT      = $04,
    cSn_CR_DISCON       = $08,
    cSn_CR_CLOSE        = $10,
    cSn_CR_SEND         = $20,
    cSn_CR_SEND_MAC     = $21,
    cSn_CR_SEND_KEEP    = $22,
    cSn_CR_RECV         = $40,
    
    cSn_IR_SENDOK       = $10,
    cSn_IR_TIMEOUT      = $08,
    cSn_IR_RECV         = $04,
    cSn_IR_DISCON       = $02,
    cSn_IR_CON          = $01,
    
    cSOCK_CLOSED        = $00,
    cSOCK_INIT          = $13,
    cSOCK_LISTEN        = $14,
    cSOCK_SYNSENT       = $15,
    cSOCK_SYNRECV       = $16,
    cSOCK_ESTABLISHED   = $17,
    cSOCK_FIN_WAIT      = $18,
    cSOCK_CLOSING       = $1A,
    cSOCK_TIME_WAIT     = $1B,
    cSOCK_CLOSE_WAIT    = $1C,
    cSOCK_LAST_ACK      = $1D,
    cSOCK_UDP           = $22,
    cSOCK_IPRAW         = $32,      // 24/3/2015 
    cSOCK_MACRAW        = $42,
    
    cIPPROTO_IP         = 0,
    cIPPROTO_ICMP       = 1,       //< Control message protocol
    cIPPROTO_IGMP       = 2,       //< Internet group management protocol
    cIPPROTO_GGP        = 3,       //< Gateway^2 (deprecated)
    cIPPROTO_TCP        = 6,       //< TCP
    cIPPROTO_PUP        = 12,      //< PUP
    cIPPROTO_UDP        = 17,      //< UDP
    cIPPROTO_IDP        = 22,      //< XNS idp
    cIPPROTO_ND         = 77,      //< UNOFFICIAL net disk protocol
    cIPPROTO_RAW        = 255      //< Raw IP packet

Public Function GetBase(n As Byte) As Byte    
    result = (1 + 4 * N )                   //< Socket N register block
End Function
    
Public Function TXBUF_BLOCK(n As Byte) As Byte
    result = (2 + 4 * N )                   //< Socket N Tx buffer address block
End Function
    
Public Function RXBUF_BLOCK(n As Byte) As Byte
    result = (3 + 4 * N )                   //< Socket N Rx buffer address block
End Function


HOST_NAME   = cHOST_NAME
TCP_PORT    = cTCP_PORT

#if USE_DHCP = true
    // With DHCP enabled and before call DHCPTask 
    // net parameters must be clean
    SetMem(@Ip_Addr,  0, 4)
    SetMem(@Sub_Mask, 0, 4)
    SetMem(@Gtw_Addr, 0, 4)
    SetMem(@Dns_Addr, 0, 4)    
#else
    // Without DHCP net parameters must be set 
    // to default values ( see on the top of this module ) 
    CArrCpy(Ip_Addr,  cIp_Addr,  4)
    CArrCpy(Sub_Mask, cSub_Mask, 4)
    CArrCpy(Gtw_Addr, cGtw_Addr, 4)
    CArrCpy(Dns_Addr, cDns_Addr, 4)
#endif

