{
*****************************************************************************
*  Name    : W5500-SOAP.BAS                                                 *
*  Author  : M.Cerutti                                                      *
*  Notice  : Copyright (c) 2014 [select VIEW...EDITOR OPTIONS]              *
*          : All Rights Reserved                                            *
*  Date    : 23/10/2014                                                     *
*  Version : 1.0                                                            *
*  Notes   :                                                                *
*          :                                                                *
*****************************************************************************
}
Module W5500_SOAP
Include "W5500"
Include "W5500-Consts"
Include "Convert"
Include "string"
Include "usart"

'Private Dim Sock As Byte
Private Dim Method(MAX_SOCK_NUM)        As String
Private Dim writeResOpen(MAX_SOCK_NUM)  As Boolean
Private Dim writeResClose(MAX_SOCK_NUM) As Boolean

{
****************************************************************************
* Name    : CheckEnvelope                                                  *
****************************************************************************
} 
Public Function CheckEnvelope(SockNum As Byte) As Boolean
'    Sock = SockNum
    result = false
    If SeekToken(SockNum, 0, "</s:Envelope>")<>-1 Then 
        result = true
    End If
End Function

{
****************************************************************************
* Name    : CheckMethod                                                    *
****************************************************************************
} 
Public Function CheckMethod(SockNum As Byte, 
                            sMethod As String, 
                            ByRef iMethodPos As Integer) As Boolean
    result = false
    iMethodPos = SeekToken(SockNum, 0, "<" + sMethod + " xmlns=")
    If iMethodPos<>-1 Then 
        result = true
    End If
End Function

{
****************************************************************************
* Name    : GetValue                                                       *
****************************************************************************
} 
Public Function GetValue(SockNum As Byte,
                         iMethodPos As Integer, 
                         sValueName As String, 
                         ByRef Value As Integer) As Boolean
    Dim i,j As Integer
    Dim s As String
    Dim len As Byte 
    result = false
    len = Length(sValueName) + 2
    If iMethodPos <>-1 Then
        i = SeekToken(SockNum, iMethodPos, "<" + sValueName + ">")
        If i<>-1 Then
            j = SeekToken(SockNum, Word(i + len), "</" + sValueName +">")
            If j<>-1 Then
                s = ""
                ExtractRXBuffer(SockNum, @s, i + len, j - i - len , true)
                Value = StrToDec(s)
                result = true
                Exit
            End If
        End If
    End If
End Function

Public Function GetValue(SockNum As Byte,
                         iMethodPos As Integer, 
                         sValueName As String, 
                         ByRef Value As Byte) As Boolean
    Dim i As Integer
    i = Integer(value)                     
    result = GetValue(SockNum, iMethodPos, sValueName, i)
    Value = Byte(i)
End Function

Public Function GetValue(SockNum As Byte,
                         iMethodPos As Integer, 
                         sValueName As String, 
                         ByRef Value As String) As Boolean
    Dim i,j As Integer
    Dim s As String
    Dim len As Byte 
    result = false
    len = Length(sValueName) + 2
    If iMethodPos <>-1 Then
        i = SeekToken(SockNum, iMethodPos, "<" + sValueName + ">")
        If i<>-1 Then
            j = SeekToken(SockNum, Word(i + len), "</" + sValueName +">")
            If j<>-1 Then
                s = ""
                ExtractRXBuffer(SockNum, @s, i + len, j - i - len , true)
                Value = s
                result = true
                Exit
            End If
        End If
    End If
End Function


Public Function GetValue(SockNum As Byte,
                         iMethodPos As Integer, 
                         sValueName As String, 
                         ByRef Value As Boolean) As Boolean
    Dim s As String
    If Value = true Then
        s = "True"
    Else
        s = "False"
    End If
    result = GetValue(SockNum, iMethodPos, sValueName, s)
    If Lowercase(s) = "true" Then
        Value = true
    Else
        Value = false
    End If
End Function


{
****************************************************************************
* Name    : WriteHTTPResponse                                              *
****************************************************************************
} 
Private Sub WriteHTTPResponse(SockNum As Byte)
    PutInTXBuffer(SockNum,("HTTP/1.1 200 OK" + #13 + #10),false)
    PutInTXBuffer(SockNum,("Content-Type: text/xml; charset=utf-8" + #13 + #10 +#13 +#10 ),false )
End Sub

{
****************************************************************************
* Name    : WriteEnvelopeOpen                                              *
****************************************************************************
} 
Private Sub WriteEnvelopeOpen(SockNum As Byte)
    PutInTXBuffer(SockNum,("<?xml version=" + #34 + "1.0" + #34 + " encoding=" + #34 + "utf-8" + #34 + "?>"),false)
    PutInTXBuffer(SockNum,("<soap:Envelope xmlns:soap=" + #34 + "http://schemas.xmlsoap.org/soap/envelope/" + #34 ),false)
    PutInTXBuffer(SockNum,(" xmlns:xsi=" + #34 + "http://www.w3.org/2001/XMLSchema-instance" + #34 ),false)
    PutInTXBuffer(SockNum,(" xmlns:xsd=" + #34 + "http://www.w3.org/2001/XMLSchema" + #34 + ">"),false)
End Sub

{
****************************************************************************
* Name    : WriteEnvelopeClose                                             *
****************************************************************************
} 
Private Sub WriteEnvelopeClose(SockNum As Byte)
    PutInTXBuffer(SockNum,"</soap:Envelope>",false)
End Sub

{
****************************************************************************
* Name    : WriteBodyOpen                                                  *
****************************************************************************
} 
Private Sub WriteBodyOpen(SockNum As Byte)
    PutInTXBuffer(SockNum,"<soap:Body>",false)
End Sub

{
****************************************************************************
* Name    : WriteBodyClose                                                 *
****************************************************************************
} 
Private Sub WriteBodyClose(SockNum As Byte)
    PutInTXBuffer(SockNum,"</soap:Body>",false)
End Sub

{
****************************************************************************
* Name    : WriteResponseOpen                                              *
****************************************************************************
} 
Private Sub WriteResponseOpen(SockNum As Byte)
    PutInTXBuffer(SockNum,("<" + Method(SockNum) + "Response xmlns=" + #34 + 
                           "http://tempuri.org/" + #34 + ">"),false)
End Sub

{
****************************************************************************
* Name    : WriteResultOpen                                                *
****************************************************************************
} 
Private Sub WriteResultOpen(SockNum As Byte)
    If Not writeResOpen(SockNum) Then
        PutInTXBuffer(SockNum, "<" + Method(SockNum) +"Result>",false)
        writeResOpen(SockNum) = true
    End If
End Sub

{
****************************************************************************
* Name    : WriteResponseClose                                             *
****************************************************************************
} 
Private Sub WriteResponseClose(SockNum As Byte)
    PutInTXBuffer(SockNum,"</" + Method(SockNum) + "Response>",false)
End Sub

{
****************************************************************************
* Name    : WriteResultClose                                               *
****************************************************************************
} 
Private Sub WriteResultClose(SockNum As Byte)
    If (writeResOpen(SockNum) = true) And (writeResClose(SockNum) = false) Then
        PutInTXBuffer(SockNum, "</" + Method(SockNum) + "Result>", false)
        writeResClose(SockNum) = true
    End If
End Sub

{
****************************************************************************
* Name    : WriteResult                                                    *
****************************************************************************
} 
Public Sub WriteResult(SockNum As Byte, Value As Boolean)
    If Not writeResOpen(SockNum) Then
        WriteResultOpen(SockNum)
    End If
    If Value Then
        PutInTXBuffer(SockNum,"true",false)
    Else
        PutInTXBuffer(SockNum,"false",false)
    End If
    WriteResultClose(SockNum)
End Sub

Public Sub WriteResult(SockNum As Byte, Value As String)
    If Not writeResOpen(SockNum) Then
        WriteResultOpen(SockNum)
    End If
    PutInTXBuffer(SockNum, Value, false)
    WriteResultClose(SockNum)
End Sub

Public Sub WriteResult(SockNum As Byte, Value As Float)
    If Not writeResOpen(SockNum) Then
        WriteResultOpen(SockNum)
    End If
    PutInTXBuffer(SockNum, FloatToStr(value), false)
    WriteResultClose(SockNum)
End Sub

Public Sub WriteResult(SockNum As Byte, Value As Integer)
    If Not writeResOpen(SockNum) Then
        WriteResultOpen(SockNum)
    End If
    PutInTXBuffer(SockNum, DecToStr(value), false)
    WriteResultClose(SockNum)
End Sub


{
****************************************************************************
* Name    : WriteItem                                                      *
****************************************************************************
} 
Public Sub WriteItem(SockNum As Byte, Value As Boolean)
    If Value Then
        PutInTXBuffer(SockNum,"<boolean>true</boolean>",false)
    Else
        PutInTXBuffer(SockNum,"<boolean>false</boolean>",false)
    End If
End Sub 

Public Sub WriteItem(SockNum As Byte, Value As String)
    PutInTXBuffer(SockNum,"<string>" + Value + "</string>",false)
End Sub 

Public Sub WriteItem(SockNum As Byte,Value As Float)
    PutInTXBuffer(SockNum,"<float>" + FloatToStr(Value) + "</float>",false)
End Sub 

Public Sub WriteItem(SockNum As Byte,Value As Integer)
    PutInTXBuffer(SockNum,"<int>" + DecToStr(value) + "</int>",false)
End Sub 

{
****************************************************************************
* Name    : WriteElementOpen                                               *
****************************************************************************
} 
Public Sub WriteElementOpen(SockNum As Byte, ElementName As String)
    If Not writeResOpen(SockNum) Then
        WriteResultOpen(SockNum)
    End If 
    PutInTXBuffer(SockNum,"<" + ElementName + ">",false)
End Sub 

{
****************************************************************************
* Name    : WriteElementClose                                              *
****************************************************************************
} 
Public Sub WriteElementClose(SockNum As Byte, ElementName As String)
    PutInTXBuffer(SockNum,"</" + ElementName + ">",false)
End Sub 

{
****************************************************************************
* Name    : WriteEmptyElement                                              *
****************************************************************************
} 
Public Sub WriteEmptyElement(SockNum As Byte, ElementName As String)
    If Not writeResOpen(SockNum) Then
        WriteResultOpen(SockNum)
    End If
    PutInTXBuffer(SockNum, "<" + ElementName + "/>",false)
End Sub 

'Public Compound Sub Write(WriteItem)

{
****************************************************************************
* Name    : WriteElement                                                   *
****************************************************************************
} 
Public Sub WriteElement(SockNum As Byte, ElementName As String, Value As Boolean )
    If Not writeResOpen(SockNum) Then
        WriteResultOpen(SockNum)
    End If
    WriteElementOpen(SockNum, ElementName)
    If value Then
        PutInTXBuffer(SockNum, "true", false)
    Else
        PutInTXBuffer(SockNum, "false", false)
    End If
    WriteElementClose(SockNum, ElementName)    
End Sub 

Public Sub WriteElement(SockNum As Byte, ElementName As String, Value As Integer)
    If Not writeResOpen(SockNum) Then
        WriteResultOpen(SockNum)
    End If
    WriteElementOpen(SockNum, ElementName)
    PutInTXBuffer(SockNum, DecToStr(Value), false)
    WriteElementClose(SockNum, ElementName)    
End Sub 

Public Sub WriteElement(SockNum As Byte, ElementName As String, Value As Float)
    If Not writeResOpen(SockNum) Then
        WriteResultOpen(SockNum)
    End If
    WriteElementOpen(SockNum, ElementName)
    PutInTXBuffer(SockNum, FloatToStr(Value), false)
    WriteElementClose(SockNum, ElementName)    
End Sub 

Public Sub WriteElement(SockNum As Byte, ElementName As String, Value As String)
    If Not writeResOpen(SockNum) Then
        WriteResultOpen(SockNum)
    End If
    WriteElementOpen(SockNum, ElementName)
    PutInTXBuffer(SockNum, Value, false)
    WriteElementClose(SockNum, ElementName)    
End Sub 


{
****************************************************************************
* Name    : Initialize                                                     *
****************************************************************************
} 
Public Sub Initialize(SockNum As Byte, sMethod As String)
    Method(SockNum)         = sMethod
    writeResOpen(SockNum)   = false
    writeResClose(SockNum)  = false
    ASyncTXBufferInit(SockNum)
    WriteHTTPResponse(SockNum)
    WriteEnvelopeOpen(SockNum)
    WriteBodyOpen(SockNum)
    WriteResponseOpen(SockNum)            
End Sub

{
****************************************************************************
* Name    : Finalize                                                       *
****************************************************************************
} 
Public Sub Finalize(SockNum As Byte)    
    If (writeResOpen(SockNum) = true) And (writeResClose(SockNum) = false) Then
        WriteResultClose(SockNum)
    End If
    WriteResponseClose(SockNum)
    WriteBodyClose(SockNum)
    WriteEnvelopeClose(SockNum)
    ASyncTXBufferSend(SockNum)
    writeResOpen(SockNum)   = false
    writeResClose(SockNum)  = false
    ReleaseRXBuffer(SockNum)
End Sub

Dim i As Byte
For i = 0 To (MAX_SOCK_NUM - 1)
    writeResOpen(i)     = false
    writeResClose(i)    = false
    Method(i)           = ""
Next 



