{
*****************************************************************************
*  Name    : W5500-Utils.BAS                                                *
*  Author  : M.Cerutti                                                      *
*  Notice  : Copyright (c) 2014 [select VIEW...EDITOR OPTIONS]              *
*          : All Rights Reserved                                            *
*  Date    : 29/10/2014                                                     *
*  Version : 1.0                                                            *
*  Notes   :                                                                *
*          :                                                                *
*****************************************************************************
}

Module W5500_Utils

Include "convert"
Include "string"

{
****************************************************************************
* Name    : CArrCmp                                                        *
* Purpose : Compare a var array with a const array, return 0 if equals     *
****************************************************************************
} 
Public Function CArrCmp(ByRef a() As Byte, ByRefConst b() As Byte, len As Byte) As Byte
    result = 1
    While len <> 0 
        Dec(len)
        If a(len) <> b(len) Then 
            Exit
        End If
    End While
    result = 0
End Function

{
****************************************************************************
* Name    : ArrCmp                                                         *
* Purpose : Compare two var arrays, return 0 if equals                     *
****************************************************************************
} 
Public Function ArrCmp(ByRef a() As Byte, ByRef b() As Byte, len As Byte) As Byte
    result = 1
    While len <> 0 
        Dec(len)
        If a(len) <> b(len) Then 
            Exit
        End If
    End While
    result = 0
End Function

{
****************************************************************************
* Name    : MemCpy                                                         *
* Purpose : Copy array bytes from sour in dest                             *
****************************************************************************
} 
Public Sub SetMem(pDest As Word, value As Byte, len As Byte)
    Save(FSR1,FSR2)
    FSR2 = pDest
    While len<>0
        Dec(len)
        POSTINC2 = value
    End While
    Restore
End Sub 


{
****************************************************************************
* Name    : CArrCpy                                                        *
* Purpose : Copy array bytes from sour const in dest                       *
****************************************************************************
} 
Public Sub CArrCpy(ByRef dest() As Byte, ByRefConst sour() As Byte, len As Byte)
    While len<>0
        Dec(len)
        dest(len) = sour(len)
    End While
End Sub 

{
****************************************************************************
* Name    : ArrCpy                                                         *
* Purpose : Copy array bytes from @sour in dest                            *
****************************************************************************
} 
Public Sub ArrCpy(pDest As Word, pSour As Word, len As Byte)
    Save(FSR1,FSR2)
    FSR2 = pDest
    FSR1 = pSour        
    While len<>0
        Dec(len)
        POSTINC2 = POSTINC1
    End While
    Restore
End Sub 

{
****************************************************************************
* Name    : ArrCpy                                                         *
* Purpose : Copy array bytes into longword dest                            *
****************************************************************************
} 
'Public Sub ArrCpy(ByRef dest As LongWord, pAddr As Word)
'    Save(FSR1)
'    FSR1 = pAddr        
'    dest.byte0 = POSTINC1 
'    dest.byte1 = POSTINC1 
'    dest.byte2 = POSTINC1 
'    dest.byte3 = INDF1 
'    Restore
'End Sub 

{
****************************************************************************
* Name    : ArrToLongWord                                                  *
* Purpose :                                                                *
****************************************************************************
} 
Public Function ArrToLongWord(pArr As Word) As LongWord
    result = 0
    Save(FSR1)
    FSR1 = pArr
    result.byte0 = POSTINC1
    result.byte1 = POSTINC1
    result.byte2 = POSTINC1
    result.byte3 = INDF1
    Restore    
End Function


{
****************************************************************************
* Name    : AddrToString                                                   *
* Purpose :                                                                *
****************************************************************************
} 
Public Function AddrToString(pArr As Word) As String
    result = ""
    Save(FSR2)
    FSR2 = pArr                          
    result = DecToStr(POSTINC2) + "." +
             DecToStr(POSTINC2) + "." +
             DecToStr(POSTINC2) + "." +
             DecToStr(INDF2) 
    Restore
End Function




